<script>
import { compile, ref, watch, h, getCurrentInstance, toValue } from "vue";

/**
 * @param {any} obj
 * @param {string} method
 * @param {Function} cb
 */
function wrap(obj, method, cb) {
  const old = obj?.[ method ];
  if (obj) {
    obj[ method ] = cb;
  }
  return () => { if (obj) { obj[ method ] = old; } }
}

export default {
  props: {
    maxState: { type: Number, default: 3 },
    template: { type: String, default: '<div></div>' }
  },
  components: {},
  setup(props, { expose }) {

    const state = ref(0);

    /** @type {null|Function} */
    let compiled = null;

    const key = ref(1);

    watch(() => props.template,
      () => {
        key.value++;
        compiled = compile(props.template);
      }, { immediate: true });

    function next() {
      state.value = (state.value + 1) % (props.maxState + 1);
    }
    expose({ next, state });

    /** @param {{ [key:string]: any }} obj */
    function objectToValues(obj) {
      return Object.entries(obj).reduce((ret, [ key, value ]) => {
        ret[key] = toValue(value);
        return ret;
      }, /** @type {{ [key:string]: any }} */ ({}));
    }

    return function render() {
      if (compiled) {
        /** @type {string|null} */
        let error = null;
        const restoreWarn = wrap(getCurrentInstance()?.appContext.config,
          "warnHandler",
          (/** @type {string} */ err) => { error = err; });
        const restoreErr = wrap(getCurrentInstance()?.appContext.config,
          "errorHandler",
          (/** @type {string} */ err) => { error = err; });
        var ret;
        try {
          ret = compiled(objectToValues({ state, key }));
        }
        catch (err) {
          error = /** @type {Error} */ (err)?.toString?.() ?? `${err}`;
        }

        restoreWarn();
        restoreErr();

        if (error) {
          return h('pre', { style: { "white-space": 'normal', color: 'red' } },
            error ?? "unknown error");
        }
        else {
          ret.key = key.value;
          return ret;
        }
      }
      else {
        return h('div', null, 'no content');
      }
    }

    // function renderError(h, err) {
    //   return h('pre', { style: { color: 'red' } }, err?.stack);
    // }
  }
}
</script>
